#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see .
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
channel=${1}
version=${2}
php_path="${setup_path}/server/php/${channel}"
j=$(calculate_j)
# 安装依赖
if [ ${OS} == "rhel" ]; then
dnf makecache
dnf groupinstall "Development Tools" -y
# openEuler 没有 libavif-devel,单独安装防止报错
dnf install libavif-devel -y
dnf install autoconf glibc-headers gdbm-devel gd gd-devel re2c systemd-devel perl oniguruma-devel libsodium-devel libxml2-devel sqlite-devel libzip-devel bzip2-devel xz-devel libpng-devel libjpeg-devel libwebp-devel freetype-devel gmp-devel openssl-devel readline-devel libxslt-devel libcurl-devel pkgconfig libedit-devel zlib-devel pcre-devel crontabs libicu libicu-devel c-ares bison -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
apt-get update
apt-get install build-essential autoconf libc6-dev libgdbm-dev libgd-tools libgd-dev re2c libsystemd-dev perl libonig-dev libsodium-dev libxml2-dev libsqlite3-dev libzip-dev libbz2-dev liblzma-dev libpng-dev libjpeg-dev libwebp-dev libavif-dev libfreetype6-dev libgmp-dev libssl-dev libreadline-dev libxslt1-dev libcurl4-openssl-dev pkg-config libedit-dev zlib1g-dev libpcre3-dev cron libicu-dev libc-ares2 libc-ares-dev bison -y
else
error "不支持的操作系统"
fi
if [ "$?" != "0" ]; then
error "安装依赖软件失败"
fi
# 准备安装目录
rm -rf ${php_path}
mkdir -p ${php_path}
cd ${php_path}
# 下载源码
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${php_path}/php-${version}.7z ${download_url}/php/php-${version}.7z
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O ${php_path}/php-${version}.7z.sha256 ${download_url}/php/php-${version}.7z.sha256
if ! sha256sum --status -c php-${version}.7z.sha256; then
rm -rf ${php_path}
error "PHP-${channel} 校验失败"
fi
7z x php-${version}.7z
rm -f php-${version}.7z
rm -f php-${version}.7z.sha256
mv php-* src
chmod -R 700 src
# 配置
cd src
# PHP <= 80 openssl3 补丁
if [ ${channel} -le "80" ]; then
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O php-${channel}-openssl3.patch ${download_url}/php/php-${channel}-openssl3.patch
wget --retry-connrefused --retry-on-host-error --retry-on-http-error=429,500,502,503,504 -t 10 -T 120 -O php-${channel}-openssl3.patch.sha256 ${download_url}/php/php-${channel}-openssl3.patch.sha256
if ! sha256sum --status -c php-${channel}-openssl3.patch.sha256; then
rm -rf ${php_path}
error "PHP-${channel} openssl3 补丁校验失败"
fi
patch -p1 >${php_path}/etc/php.ini
echo ";The following panel flags are not allowed to be deleted, otherwise PHP extensions cannot be installed!" >>${php_path}/etc/php.ini
echo ";panel" >>${php_path}/etc/php.ini
# 安装 zip 拓展
cd ${php_path}/src/ext/zip
${php_path}/bin/phpize
./configure --with-php-config=${php_path}/bin/php-config
make "-j${j}"
make install
if [ "$?" != "0" ]; then
rm -rf ${php_path}
error "PHP-${channel} zip 拓展安装失败"
fi
echo "extension=zip" >>${php_path}/etc/php.ini
cd ${php_path}/src
# 设置软链接
if [ ! -f /usr/bin/php ]; then
ln -sf ${php_path}/bin/php /usr/bin/php
fi
ln -sf ${php_path}/bin/php /usr/bin/php${channel}
ln -sf ${php_path}/bin/php /usr/bin/php-${channel}
ln -sf ${php_path}/bin/phpize /usr/bin/phpize
ln -sf ${php_path}/bin/pear /usr/bin/pear
ln -sf ${php_path}/bin/pecl /usr/bin/pecl
ln -sf ${php_path}/sbin/php-fpm /usr/bin/php-fpm-${channel}
# 设置fpm
cat >${php_path}/etc/php-fpm.conf <${setup_path}/server/nginx/conf/enable-php-${channel}.conf <